(function(){
  var _, react, DOM, modalss, ref$, Map, List, OrderedMap, ModalWrap, ModalHandlerProto, Modals;
  _ = require('lodash');
  react = require('react'), DOM = react.DOM;
  modalss = require('./registry');
  ref$ = require('immutable'), Map = ref$.Map, List = ref$.List, OrderedMap = ref$.OrderedMap;
  ModalWrap = react.createFactory(react.createClass({
    displayName: 'ModalWrap',
    shouldComponentUpdate: function(){
      return this.props.data !== arguments[0].data;
    },
    render: function(){
      var data;
      data = this.props.data;
      return react.createElement(data.get(0), data.get(1));
    }
  }));
  ModalHandlerProto = {
    setProps: function(props){
      this.modals.setModalProps(this, this.id, props);
    },
    dispose: function(){
      this.modals.disposeModal(this.id);
    }
  };
  Modals = react.createFactory(react.createClass({
    displayName: 'Modals',
    getInitialState: function(){
      var modalsId, ref$;
      modalsId = (ref$ = this.props.modalsId) != null ? ref$ : '';
      if (modalss[modalsId] != null) {
        throw "Can't create Modals with duplicate modals-id: " + modalsId;
      }
      modalss[modalsId] = this;
      this.uid = 0;
      return {
        windows: this._windows = OrderedMap()
      };
    },
    componentWillReceiveProps: function(){
      if (this.props.modalsId !== arguments[0].modalsId) {
        throw 'modals-id of Modals can not be changed after initializing';
      }
    },
    componentWillUnmount: function(){
      var modalsId, ref$;
      modalsId = (ref$ = this.props.modalsId) != null ? ref$ : '';
      modalss[(ref$ = this.props.modalsId) != null ? ref$ : ''] = null;
    },
    childDidDisposed: function(id){
      var callback;
      callback = this._windows.get(id).get(1).modalDidDisposed;
      this.setState({
        windows: this._windows = this._windows.remove(id)
      });
      if (typeof callback == 'function') {
        callback();
      }
    },
    setModalProps: function(handle, id, props){
      var this$ = this;
      return this.setState({
        windows: this._windows = this._windows.update(id, function(it){
          return it.set(1, _.assign(_.omit(props, ['modalsId', 'component']), {
            handle: handle,
            modalDispose: it.get(2),
            childDidDisposed: this$.childDidDisposed.bind(this$, id)
          }));
        })
      });
    },
    disposeModal: function(id){
      var this$ = this;
      if (!this._windows.has(id)) {
        return;
      }
      return this.setState({
        windows: this._windows = this._windows.update(id, function(it){
          return it.set(2, true).update(1, (function(it){
            return it.modalDispose = true, it;
          }));
        })
      });
    },
    reg: function(component, props){
      var id, handle;
      while (this._windows.has(id = ++this.uid % Number.MAX_SAFE_INTEGER)) {}
      handle = import$(Object.create(ModalHandlerProto), {
        id: id,
        modals: this
      });
      props = _.assign(_.omit(props, ['modalsId', 'component']), {
        handle: handle,
        modalDispose: false,
        childDidDisposed: this.childDidDisposed.bind(this, id)
      });
      this.setState({
        windows: this._windows = this._windows.set(id, List([component, props, false]))
      });
      return handle;
    },
    render: function(){
      var this$ = this;
      if (!this._windows.size) {
        return null;
      }
      return DOM.div(_.assign({}, this.props), this._windows.map(function(){
        return ModalWrap({
          key: arguments[1],
          data: arguments[0]
        });
      }).valueSeq());
    }
  }));
  module.exports = {
    Modals: Modals
  };
  function import$(obj, src){
    var own = {}.hasOwnProperty;
    for (var key in src) if (own.call(src, key)) obj[key] = src[key];
    return obj;
  }
}).call(this);
